/**
 * IdentityMessage.
 *
 * @author     Sean C. Rhea
 * @version    $Id: IdentityMessage.java,v 1.13 2002/08/08 23:10:32 srhea Exp $
 */

package ostore.network;
import java.util.Iterator;
import java.util.LinkedList;
import ostore.util.InputBuffer;
import ostore.util.NodeId;
import ostore.util.OutputBuffer;
import ostore.util.OutputBuffer;
import ostore.util.QSException;
import ostore.util.QuickSerializable;

public class IdentityMessage 
extends NetworkMessage implements QuickSerializable {

    public LinkedList node_ids;

    public IdentityMessage (NodeId peer, NodeId n) {
	super (peer, false);
	node_ids = new LinkedList ();
	node_ids.addLast (n);
    }

    public IdentityMessage (NodeId peer, LinkedList nids) {
	super (peer, false);
	node_ids = nids;
    }

    public IdentityMessage (InputBuffer buffer) 
    throws QSException {
	super (buffer);
	int count = buffer.nextInt ();
	node_ids = new LinkedList ();
	while (count-- > 0) 
	    node_ids.addLast ((NodeId) buffer.nextObject ());
    }

    public void serialize (OutputBuffer buffer) {
	super.serialize (buffer);
	buffer.add (node_ids.size ());
	Iterator i = node_ids.iterator ();
	while (i.hasNext ())
	    buffer.add ((NodeId) i.next ());
    }

    public String toString () {
	String result = "(IdentityMessage " + super.toString ();
	Iterator i = node_ids.iterator ();
	while (i.hasNext ())
	    result += " " + (NodeId) i.next ();
	return result + ")";
    }
}

