#!/usr/bin/perl -w

##############################
# Generate a SandStorm config file with certain parameters.

$| = 1;

# read in parameters
($sparse, $machine, $trace_num, $period, $M) = @ARGV;
if( ! $M ) {
    print "USAGE:\tgenconfig.pl (sparse|nosparse) <machinename> <trace_num> <period> <num_clusters>\n";
    exit 1;
} else {
    print "Preparing simulation for the trace $trace_num on machine $machine\n";
    print " period: $period, M: $M, $sparse\n";
}

# generate new directory for this run
$code = "$sparse.$machine.$trace_num.$period.$M";
mkdir $code, 0755;
#chmod 0755 $code;

# generate new config files
open( CONFIG, "run.cfg" );
open( RUN, ">$code/run.cfg" );
open( TEST, ">$code/test.cfg" );

while( <CONFIG> ) {
    if( $_ =~ /trace/ ) {
	$name = "/scratch/seer/observer.save.$machine.0000$trace_num.gz";
	print RUN "\ttrace $name\r\n";
	print TEST "\ttrace $name\r\n";
    } elsif( $_ =~ /num_clusters/ ) {
	print RUN "\tnum_clusters $M\r\n";
	print TEST "\tnum_clusters $M\r\n";
    } elsif( $_ =~ /period/ ) {
	print RUN "\tperiod $period\r\n";
	print TEST "\tperiod 1000000\r\n";
    } else {
	print RUN $_;
	print TEST $_;
    }
}
