/**
 * QSSha1RsaSignature.
 *
 * @author     Sean C. Rhea
 * @version    $Id: QSSha1RsaSignature.java,v 1.12 2002/07/20 22:19:35 srhea Exp $
 */

package ostore.security;
import ostore.util.*;
import java.security.*;

/**
 * A QSSignature subtype for RSA/SHA-1 signatures.
 * 
 * @author   Sean C. Rhea
 * @version  $Id: QSSha1RsaSignature.java,v 1.12 2002/07/20 22:19:35 srhea Exp $
 *
 * @see SignedQS
 */
public class QSSha1RsaSignature implements QSSignature {

    /**
     * The default constructor.
     */
    public QSSha1RsaSignature () {}

    /**
     * The deserialization constructor.  See the comments at the top of
     * {@link ostore.util.QuickSerializable} for details.
     */
    public QSSha1RsaSignature (InputBuffer buffer) {}

    public String algorithm () { return "SHA-1/RSA/PKCS#1"; }
    public String provider () { return "CryptixCrypto"; }

    public void serialize (OutputBuffer buffer) {}

    public int hashCode () {
	return (int) TypeTable.type_code (this);
    }

    public boolean equals (Object obj) {
	return (obj instanceof QSSha1RsaSignature);
    }
    
    public String toString () { return "QSSha1RsaSignature"; }
}

