
package ostore.security.thresh;
import java.math.BigInteger;
import ostore.security.SafeBigInt;
    
public class NativeIF {

    public static native void sign_using_c_helper (
	    BigInteger x, BigInteger n, BigInteger r, 
	    BigInteger groupVerifier, BigInteger delta, 
	    BigInteger verifier, BigInteger signVal, BigInteger secret,
	    BigInteger [] results, boolean debug);

    public static native BigInteger package_up_c_helper (
	    int l, BigInteger n, BigInteger e, 
	    BigInteger [] sigs, int [] lambdas, 
	    boolean debug);

    public static native boolean verify_c_helper (
	    byte [] data, byte [] combined_sig, int l, 
	    BigInteger n, BigInteger e);

    public static boolean available = true;

    static {
	try {
	    System.loadLibrary ("ostore_security_thresh_libgmp");
	}
	catch (UnsatisfiedLinkError e1) {
	    try {
		System.loadLibrary ("ostore_security_thresh_libcrypto");
	    }
	    catch (UnsatisfiedLinkError e2) {
		System.err.println ("Could not load JNI " +
			"cryptography code.  Using Java implementation " +
			"instead.  (This will affect performance, but " +
			"not correctness.)");
		available = false;
	    }
	}
    }
}

