package ostore.tapestry.channel;


import seda.sandStorm.api.*;
import seda.sandStorm.core.ssTimer;
import seda.sandStorm.internal.SinkProxy;

import ostore.util.Carp;
import ostore.util.SHA1Hash;

import ostore.util.Debug;
import ostore.util.DebugFlags;
import ostore.util.NodeId;
import ostore.util.Pair;
import ostore.util.SecureHash;
import ostore.util.QuickSerializable;
import ostore.util.QuickSerializable;
import ostore.util.TypeTable;
import ostore.util.Types;
import ostore.dispatch.Classifier;
import ostore.dispatch.Signal;
import ostore.dispatch.Filter;
import ostore.tapestry.api.TapestryPublishMsg;
import ostore.tapestry.impl.TapestryReadyMsg;
import ostore.util.QSString;
import ostore.util.QSIO;
import ostore.security.QSPublicKey;
import ostore.tapestry.api.TapestryLocateFailure;
import seda.sandStorm.api.ConfigDataIF;
import seda.sandStorm.api.EventHandlerIF;
import seda.sandStorm.api.UnknownEventException;
import seda.sandStorm.api.QueueElementIF;
import seda.sandStorm.api.SinkIF;
import seda.sandStorm.api.SinkFullException;
import seda.sandStorm.internal.SinkProxy;
import java.io.FileInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;

public class PingStage implements EventHandlerIF{
    
    private NodeId my_node_id;
    private NodeId dest_node_id;
    private Classifier _classifier;
    private Signal signal;
    private SinkIF _this_sink;
    private ssTimer _timer;
    private String stageName;
    private QSPublicKey _pkey;
    private SecureHash _my_id;
    private SecureHash _dest_id;

    public void handleEvent(QueueElementIF element)
	throws EventHandlerException{
	if (element instanceof StagesInitializedSignal){

	}else if(element instanceof TapestryReadyMsg){
	    signal.alarm("pingStage", 20000);
	}else if(element instanceof Signal.AlarmSignal){
	    /*
	    try{
		System.out.println("-------Sending ICMP ping message.-------");//xxx
		    
		ICMPPingMsg msg = new ICMPPingMsg(dest_node_id, _my_id, _dest_id);
		_classifier.dispatch(msg);
		
		
	    }catch(Exception e){
		e.printStackTrace();
		}*/
	    System.out.println("PingStage > Sending ICMP ping messge");
	    handleUserInput();
	    signal.alarm("pingStage", 100);
	}else if(element instanceof ICMPPongMsg){
	    ICMPPongMsg msg = (ICMPPongMsg)element;
	    System.out.println("yeah..got an ICMPPongMsg " + msg.hop);
	    //dest_node_id = 
	    //new NodeId(config.getString("address")+":"+config.getString("port"));
	}
    }
    
    //for testing purpose
    private void handleUserInput(){
	String address="";
	String port="";
	BufferedReader br
	    = new BufferedReader(new InputStreamReader(System.in));

	while(true){
	    System.out.println("Enter Address>");
	    try{
		address=br.readLine();
		break;
	    }catch(IOException e){
		e.printStackTrace();
	    }
	}
	
	while(true){
	    System.out.println("Enter Port>");
	    try{
		port=br.readLine();
		break;
	    }catch(IOException e){
		e.printStackTrace();
	    }
	}

	try{
	    dest_node_id = new NodeId(address+":"+port);
	    _dest_id = new SHA1Hash(dest_node_id);
	
	    //ICMPPingMsg msg = new ICMPPingMsg(dest_node_id, _my_id, _dest_id);
	    ICMPPingMsg msg = new ICMPPingMsg(null, null, _my_id, _dest_id);
	    //ICMPPingMsg msg = new ICMPPingMsg(dest_node_id, _my_id, _dest_id);
	    _classifier.dispatch(msg);
	}catch(Exception e){
	    e.printStackTrace();
	}
    }

    public void handleEvents(QueueElementIF elements[])
	throws EventHandlerException{
	for(int i = 0 ; i < elements.length; i++){
	    handleEvent(elements[i]);
	}
    }
    
    public void init(ConfigDataIF config) throws Exception{
	
	TypeTable.register_type("ostore.tapestry.channel.ICMPPingMsg");
	TypeTable.register_type("ostore.tapestry.channel.ICMPPongMsg");
	TypeTable.register_type("ostore.tapestry.channel.ICMPPingRouteMsg");
	Types.registerAllTypes();
	
	my_node_id = new NodeId(config.getString("node_id"));
	System.out.println("PingStage: my_node_id is " + my_node_id);//xxx
	_classifier = Classifier.getClassifier(my_node_id);
	signal = Signal.getSignal(my_node_id);
	
	//dest_node_id = 
	//new NodeId(config.getString("address")+":"+config.getString("port"));
	System.out.println("from PingStage: dest_node_id: " + dest_node_id);//xxx

	String keyfilename = config.getString("pkey");
	try{
	    FileInputStream keyfile = new FileInputStream(keyfilename);
	    _pkey = (QSPublicKey) QSIO.read(keyfile);
	    keyfile.close();
	}catch(Exception e){
	    Carp.die ( "TClient.init: Caught exception " + e + 
		       "while trying to read pkey from disk.");
	}
	
	//_my_id = new SHA1Hash(_pkey);
	_my_id = new SHA1Hash(my_node_id);
	//_dest_id = new SHA1Hash(dest_node_id);
	String stageName = config.getStage().getName();
	try{
	    if( config.getBoolean("Profile") ){
		SinkIF sink = 
		    config.getManager().getStage(stageName).getSink();
		_this_sink = new SinkProxy(sink,
					   config.getManager(),
					   config.getStage().getWrapper());
		config.getManager().getProfiler().add("ostore.proxy.SDTcpClient", (SinkProxy)_this_sink );
	    }else{
		_this_sink =
		    config.getManager().getStage(stageName).getSink();
	    }
	}catch(NoSuchStageException e){
	    Carp.die(stageName + ".init:ascouldn ot get own sink.");
	}
	
	signal.register( Signal.ALRM, "pingStage", _this_sink  );
	registerInitialStageFilters();
    }

    private void registerInitialStageFilters() 
	throws Exception
    {
	String[] msg_types = {
	    "ostore.tapestry.impl.TapestryReadyMsg",
            "seda.sandStorm.api.StagesInitializedSignal",
	    "ostore.tapestry.channel.ICMPPongMsg"
	};

        for (int i = 0; i < msg_types.length; ++i)
        {
            Filter filter = new Filter();
            if (! filter.requireType(Class.forName(msg_types[i])))
            {
                Carp.die(stageName + ": Could not filter on type " +
                         msg_types[i]);
            }
            if (! _classifier.subscribe(filter, _this_sink))
            {
                Carp.die(stageName + ": Could not subscribe for type " +
                         msg_types[i]);
            }
        }
	
    }

    public void destroy() throws Exception{
	
    }

}


