/**
 * NodeState.java
 *
 * This class is a quick way of encapsulating the amount of state 
 * associated with a distinct multicast at a particular node.  It's
 * accessed primarily in MulticastState.
 *
 * @author Ben Y. Zhao
 * @version $Id: NodeState.java,v 1.2 2003/04/26 00:27:45 strib Exp $
 */

package ostore.tapestry.impl;
import ostore.util.NodeId;
import ostore.util.SecureHash;
import java.util.HashSet;
import java.util.HashMap;
import java.util.TreeSet;

public class NodeState {
  public SecureHash newguid;  //the guid of this particular mc state
  public int alpha;   //the alpha that this multicast arrived with
  public NodeId parent; //the parent of this multicast for this node
  public NodeId addr;   //address of the new node being inserted
  public HashSet mcaddrs; //list of outstanding multicasts
  public TreeSet locks;
  public boolean notified; //has the new node acked our notify message
  
  public NodeState (SecureHash guid) {
    newguid = guid;
    locks = new TreeSet();
    mcaddrs = new HashSet();
    notified = false;
  }
  
  public NodeState (SecureHash guid, int a, NodeId p, 
		    NodeId add, TreeSet l) {
    newguid = guid;
    alpha = a;
    parent = p;
    addr = add;
    mcaddrs = new HashSet();
    locks = l;
    notified = false;
  }
  
  public void addMCast(NodeId newaddr) {
    mcaddrs.add(newaddr);
  }
}
