/**
 * TestFoundMsg.java
 *
 * @author     Ben Y. Zhao
 * @version    $Id: ShuttleHelloMsg.java,v 1.8 2002/10/30 10:30:58 calvinh Exp $
 */

package ostore.tapestry.impl.Shuttle;

import ostore.tapestry.impl.*;

import ostore.util.QSException;
import ostore.util.SecureHash;
import ostore.util.OutputBuffer;
import ostore.util.ByteUtils;
import ostore.util.TypeTable;
import ostore.tapestry.api.TapestryRouteMsg;
import ostore.util.InputBuffer;
import ostore.util.QuickSerializable;
/**
 * The msg to say we found the object you're looking for
 */
public class ShuttleHelloMsg 
    extends TapestryRouteMsg implements QuickSerializable {

    public SecureHash objGuid;

  public ShuttleHelloMsg (SecureHash dest_guid, SecureHash oguid) {
    super (dest_guid);
    this.objGuid = oguid;
  }

    public ShuttleHelloMsg (InputBuffer buffer) throws QSException {
	super(buffer);
	objGuid = (SecureHash) buffer.nextObject();
    }

    public void serialize (OutputBuffer buffer) {
	super.serialize(buffer);
	buffer.add(objGuid);
    }
  
 

  public String toString() {
    return "(ShuttleHelloMsg for object "+objGuid+", from/to="+ peer+ ")";
  }

    
}


