/**
 * MicroBarrierMsg.java
 *
 * @author     Ben Y. Zhao
 * @version    $Id: MicroBarrierMsg.java,v 1.8 2002/07/21 08:54:46 ravenben Exp $
 */

package ostore.tapestry.impl.test;
import ostore.tapestry.impl.*;
import ostore.util.QSException;
import ostore.util.SecureHash;
import ostore.util.OutputBuffer;
import ostore.tapestry.api.TapestryRouteMsg;
import ostore.util.InputBuffer;
import ostore.util.QuickSerializable;

/**
 * The msg to say we're done with publishing our object, and ready to locate
 */
public class MicroBarrierMsg 
extends TapestryRouteMsg implements QuickSerializable {

    public int size;

    public MicroBarrierMsg (SecureHash dest_guid, int size) {
      super (dest_guid);
      this.size = size;
    }

    public MicroBarrierMsg (InputBuffer buffer) throws QSException {
      super(buffer);
      size = buffer.nextInt();
    }

    public void serialize (OutputBuffer buffer) {
      super.serialize (buffer);
      buffer.add(size);
    }
}


