package ostore.tapestry.impl.test;
import ostore.tapestry.patchwork.ProbPDF;
import ostore.tapestry.patchwork.CDF;

/** Specifies a CDF and a PDF in hours for the Gnutella trace */
public class ObjectLocationPDF implements ProbPDF, CDF {

    // fail 20% of the nodes (DEFAULT)
    private double failrate = .2;

    // how many periods to fail after (DEFAULT)
    private int failperiod = 5;
    // how often is this checked?
    private int failincrement = 60000;

    public java.util.Random rand = new java.util.Random();

    public double getPDFEntry( int n ) {
	if( (n+1) == failperiod && rand.nextDouble() < failrate ) {
	    return 1;
	} else {
	    return 0;
	}
    }

    public int getPDFSize() {
	return Integer.MAX_VALUE;
    }

    public int getPDFIncrement() {
	return failincrement;
    }

    public void setSeed( long seed ) {
	rand.setSeed( seed );
    }

    public void setRate( double rate ) {
	failrate = rate;
    }

    public void setInterval( int interval ) {
	failperiod = interval;
    }

    public double getCDFEntry( int n ) {
	return 0;
    }

    public int getCDFSize() {
	return getPDFSize();
    }

    public int getCDFIncrement() {
	return getPDFIncrement();
    }

}
