package ostore.tapestry.interweave;
import ostore.tapestry.api.*;
import ostore.util.NodeId;
import ostore.util.SecureHash;
import ostore.util.ByteUtils;
import ostore.util.QSException;
import ostore.util.OutputBuffer;
import ostore.util.QuickSerializable;
import ostore.util.InputBuffer;

/**
 * InterweaveErrorMsg.java
 *
 * The message that signals an error.
 *
 * @author Benjamin K. Poon
 */
public class InterweaveErrorMsg 
    extends TapestryRouteMsg implements QuickSerializable {

    public SecureHash from;
    public String errorMsg;

    public InterweaveErrorMsg (SecureHash to, SecureHash from, String errorMsg) {
	super(to);
	this.from = from;
	this.errorMsg = errorMsg;
    }

    public InterweaveErrorMsg (InputBuffer buffer) throws QSException {
	super(buffer);
	from = (SecureHash)buffer.nextObject();
    }
    
    public void serialize (OutputBuffer buffer) {
	super.serialize (buffer);
	buffer.add(from);
    }
    
    public Object clone () throws CloneNotSupportedException {
	InterweaveErrorMsg result = (InterweaveErrorMsg) super.clone();
	result.from = from;
	return result;
    }

    public String toString() {
	return "(InterweaveErrorMsg: from="+from+")";
    }

}
