package ostore.tapestry.interweave;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import ostore.tapestry.impl.*;
import java.util.*;
import java.io.*;
import java.security.*;

public class JInterweaveFrame 
    extends JFrame implements ActionListener {

    private Interweave InterweaveParent;
    private JMenuBar menuBar;
    private JMenu menu, submenu;
    private JMenuItem menuItem;
    
    public JInterweaveFrame(Interweave parent) {
	
	super("Interweave");

	InterweaveParent = parent;
     	
	// Create the menu bar
	menuBar = new JMenuBar();
	setJMenuBar(menuBar);

	// Build the FILE menu
	menu = new JMenu("File");
	menu.setMnemonic(KeyEvent.VK_F);
	menuBar.add(menu);

	menuItem = new JMenuItem("Search", KeyEvent.VK_S);
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK));
	menu.add(menuItem);

	menu.addSeparator();
	
	menuItem = new JMenuItem("Connect", KeyEvent.VK_C);
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, ActionEvent.CTRL_MASK));
	menu.add(menuItem);

	menuItem = new JMenuItem("Disconnect", KeyEvent.VK_D);
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_D, ActionEvent.CTRL_MASK));
	menu.add(menuItem);

	menuItem = new JMenuItem("Exit", KeyEvent.VK_E);
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F4, ActionEvent.ALT_MASK));
	menu.add(menuItem);
	
	// Build the VIEW menu
	menu = new JMenu("View");
	menu.setMnemonic(KeyEvent.VK_V);
	menuBar.add(menu);

	menuItem = new JMenuItem("Search Results", KeyEvent.VK_S);
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1, ActionEvent.ALT_MASK));
	menu.add(menuItem);

	menuItem = new JMenuItem("Downloaded Files", KeyEvent.VK_D);
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_2, ActionEvent.ALT_MASK));
	menu.add(menuItem);

	menuItem = new JMenuItem("Shared Files", KeyEvent.VK_H);
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_3, ActionEvent.ALT_MASK));
	menu.add(menuItem);

	// Build the OPTIONS menu
	menu = new JMenu("Options");
	menu.setMnemonic(KeyEvent.VK_O);
	menuBar.add(menu);

	menuItem = new JMenuItem("Set Download Directory", KeyEvent.VK_D);
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_D, ActionEvent.ALT_MASK));
	menu.add(menuItem);

	menuItem = new JMenuItem("Set Shared Directory", KeyEvent.VK_S);
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.ALT_MASK));
	menu.add(menuItem);

	// Build the Help menu
	menu = new JMenu("Help");
	menu.setMnemonic(KeyEvent.VK_H);
	menuBar.add(menu);

	menuItem = new JMenuItem("Contents", KeyEvent.VK_C);
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F1, ActionEvent.ACTION_PERFORMED));
	menu.add(menuItem);

	menu.addSeparator();

	menuItem = new JMenuItem("About Interweave", KeyEvent.VK_D);
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_2, ActionEvent.ALT_MASK));
	menu.add(menuItem);

        getContentPane().add(new TabPane(), BorderLayout.CENTER);

	pack();
    }

    public void actionPerformed(ActionEvent e) {
        JMenuItem source = (JMenuItem)(e.getSource());

	System.out.println(source.getText());

    }

}

class TabPane extends JPanel {
    public TabPane() {
        JTabbedPane tabbedPane = new JTabbedPane();
        Component searchPanel = makeTextPanel("Search");
        tabbedPane.addTab("Search", null, searchPanel, "Search for files and display search results");
        tabbedPane.setSelectedIndex(0);

        Component downloadedPanel = makeTextPanel("Downloaded Files");
        tabbedPane.addTab("Downloaded Files", null, downloadedPanel, "Displays files in the download directory");

        Component sharedPanel = makeTextPanel("Shared Files");
        tabbedPane.addTab("Shared Files", null, sharedPanel, "Displays files in the shared directory");

        //Add the tabbed pane to this panel.
        setLayout(new GridLayout(1, 1)); 
        add(tabbedPane);
    }

    protected Component makeTextPanel(String text) {
        JPanel panel = new JPanel(false);
        JLabel filler = new JLabel(text);
        filler.setHorizontalAlignment(JLabel.CENTER);
        panel.setLayout(new GridLayout(1, 1));
        panel.add(filler);
        return panel;
    }
}
    
