#!/usr/bin/perl -w
#
# $Id: copy_remote.pl,v 1.3 2002/11/12 23:11:33 geels Exp $

use strict;
use Getopt::Long;
$Getopt::Long::order = $REQUIRE_ORDER;	# Stop processing at file list.

my $remote_dir = "";	# leave in $HOME by default.
my $help;
my $parallel;
&GetOptions( "help|?" => \$help, "remote-dir=s" => \$remote_dir,
	     "parallel|j:i" => \$parallel )
    or &usage() and exit( -1 );

if( $help ) {
    &usage() and exit( 0 );
}

my @local_files = @ARGV;
if( ! @local_files ) {
    &usage() and exit( -1 );    
}

sub usage {
    print "\nUSAGE:\t copy_remote.pl [--parallel [<max>]] " .
	"[--remote-dir <directory>] file1 ... fileN \n\n";
}

my @iterator_args = ("--mode", "scp", "--remote-dir", $remote_dir);
if( defined $parallel ) {
    my $num_parallel = ($parallel or 10);
    push @iterator_args, ("--parallel", $num_parallel);
}
push @iterator_args, ("copy_remote", @local_files);

exec( "./call_iterator.pl", @iterator_args );
