#!/usr/bin/perl 
# Written by Anthony D. Joseph (adj@eecs.berkeley.edu)
# August 25, 2002


require "getopts.pl";
&Getopts("s:d:");  # s for <# of static nodes>, d for <# of dynamic nodes>

($#ARGV == 0) || &usage;
$head = $ARGV[0];

#
# Initialize
#
$Static = 0;
if ($opt_s) {
    $Static = "$opt_s";
} else {
    $Static = 2;
}

$Dynamic = 0;
if ($opt_d) 
{
    $Dynamic = "$opt_d"
} else {
    $Dynamic = 0;
}

print "# of Static  node: $Static\n";
print "# of Dynamic node: $Dynamic\n";

sub usage {
    die("Usage: gen_exp.pl [-s <# of static nodes>] [-d <# if dynamic nodes>] head.exp");
}

$exp_file = "/tmp/tapestry_planetlab_s" . $Static . "_d" . $Dynamic . ".exp";
print "Generate file: $exp_file\n";
system "cp $head $exp_file";
open(NODES, ">> $exp_file") || die( "ERROR: could not open $exp_file" );

my $num = 0;
my @indices;
my $index = 490;
$range = 490;
$indices[$num] = $index;
print NODES "Drive   /tmp/fulltest-driver-$Static-sim.cfg     dynamic       daemon  0  $indices[$num]\n";
$num++;

$indices[$num] = generates_unique_number($range, @indices);
print NODES "Federation   \${run_dir}/federation.cfg         fed       daemon  0  $indices[$num]\n";
$num++;

for $i (0 .. $Dynamic - 1) 
{
    $indices[$num] = generates_unique_number($range, @indices);
    print NODES "MEM$i         \${run_dir}/fulltest-member-local.cfg    dynamic   mortal  0  $indices[$num]\n";
    $num++;
}

for $i ($Dynamic .. $Dynamic + $Static - 1) 
{
    $indices[$num] = generates_unique_number($range, @indices);
    print NODES "MEM$i         \${run_dir}/fulltest-member-local.cfg    static    mortal  0  $indices[$num]\n";
    $num++;
}

close(NODES);

sub contains 
{
    my ($value, @array) = @_; 
    my $ele;
    foreach $ele (@array) 
    {
	if ($ele == $value)
	{
	    return 1;
	}
    }

    return 0;
}

sub generates_unique_number
{
    my ($range, @indices) = @_; 

    my $index = int(rand($range)) + 1;
    while ( contains($index, @indices) == 1)
    {
	$index = int(rand($range)) + 1;
    }

    return $index;
}
