#!/usr/bin/perl 
# Written by Anthony D. Joseph (adj@eecs.berkeley.edu)
# August 25, 2002

use Tools;

my %value_map;
my @nodes = (2, 5, 10, 16, 20, 40, 70, 100, 150, 200, 256, 300, 350, 400, 450, 500);
my $base_port;

my $day = `date +%d`;
my $month = `date +%m`;
my $time = `date +%T`;
chomp ($day);
chomp ($month);
chomp ($time);
my $file_time = $month . $day . "_" . $time;
my $result_log = "/home/hling/planetlab/" . $file_time . "_probing_bw_raw.log";
my $result_file = "/home/hling/planetlab/" . $file_time. "_probing_bw_raw.dat.dat";
open (OUT, ">$result_file");

$i = 9;
#for $i (0 .. 11)
{
    $base_port = 7275;
#    for $j (0 .. 10)
    {
	system "rm -rf /tmp/*.cfg";
	system "rm -rf /tmp/*.log";
	system "rm -rf /tmp/*.exp";
	system "rm -rf /tmp/*.map";
	system "rm -rf /tmp/*.tmp";
	print "Killall java...\n";
	system "killall -9 java";
#	system "killall_java_remote";

	print "Generate exp files...\n";
	system "./gen_exp_sim.pl -s $nodes[$i] -d 0 head_sim.exp";
	my $Static  = $nodes[$i];
	my $Dynamic = 0;
	my $all_nodes = $Static + $Dynamic;
	my $template = "fulltest-driver-sim.cfg";
	$driver_cfg   = "/tmp/fulltest-driver-$nodes[$i]-sim.cfg";
	$driver_log   = "/tmp/fulltest-driver-$nodes[$i]-sim.log";
	$value_map{"NodeNumber"} = "$all_nodes";
	# Now write the new, interpolated file.
	print "Generate cfg files...\n";
	&interpolate( $template, $driver_cfg, \%value_map );

	# Start the driver node and wait to see that it's running.
#	print "Start drive node...\n";
#	&fork_sandstorm( $driver_cfg, $driver_log);
#	&wait_for_network_ready( $driver_log );
	
	print "Run Experiment...\n";
	$base_port = $base_port + 10;
	my $exp_file = "/tmp/tapestry_planetlab_s" . $Static . "_d" . $Dynamic . ".exp";
#	system "run-experiment -port $base_port $exp_file";
	system "./run-experiment --simulator --successes_expected 0 $exp_file";

	print "Waiting for Succeed...\n";
	&wait_for( $driver_log, "probing_bandwidth: Succeed in probing" );

	print "Test finished. Parsing results...\n";
	my $result_string = `grep "USEFUL_DATA" /tmp/*.log`;
#    $result_string =~ s/Complete:\s*(\S*)/$1/;
	print OUT "$nodes[$i] nodes with port number = $base_port: \n$result_string";
    }

    print OUT "\n";
}

close OUT;
